#include "main.h"



// Funo usada para verificar se o arquivo e dados de configurao esto corretos.

int ichkConfigFile()
{

FILE *arqconf; 

#ifdef MYSQL_TOMEINC
    FILE *arqmysqlconf;
#endif

char buff[MAXLINHA],
     *ptr,
     *endptr;
struct stat statinfo;

#ifdef DEBUG
   int iTMP=0,
       iTMP2=0;
#endif

	iEmpresa=-1;
	iEmails=0;

	//Verifica se o arquivo de configurao existe
	if(stat(CONF_FILE,&statinfo))
	{
		printf("Configuration file \"/etc/ftpmond/ftpmond.conf\" not found.\n");
		return -1;
	}
	
	//abre o arquivo de configurao
	if((arqconf=fopen(CONF_FILE,"r"))==NULL)
	{
		printf("Configuration file \"ftpmond.conf\" cannot open.\n");
		return -1;
    }

	
	while(fgets(buff,MAXLINHA,arqconf))
    {
		//Descarta os comentrios
		if(!(strncmp(buff,"#",1)))
			continue;

		//Captura o nome do grupo de e-mails
		if(!(strncmp(buff,"[",1)))
		{
			//verifica se o grupo anterior possui pelo menos um email
			if((strlen(stconf[iEmpresa].emails[0])<4) && (iEmpresa>=0)){
				printf("Erro:O grupo %s no possui e-mail.\n",stconf[iEmpresa].empresa);
				return (-1);
			}

			ptr=buff;
			ptr++;
			if(!(endptr=strchr(ptr,']')))
			{
				printf("Erro no arquivo \"ftpmond.conf\". TAG [] no est correta.\n");
				return (-1);
			}
			iEmpresa++; //cria um novo grupo
			iEmails=0; //inicializa os e-mails
			strncpy(stconf[iEmpresa].empresa,ptr,endptr-ptr); //guarda o nome da empresa
			stconf[iEmpresa].empresa[endptr-ptr]='\0';
			continue;
		}

		//Captura os e-mails
		if((ptr=strchr(buff,'@')))
		{
			ptr=buff;
			strncpy(stconf[iEmpresa].emails[iEmails],ptr,(strlen(ptr)-1));
			stconf[iEmpresa].emails[iEmails][(strlen(ptr)-1)]='\0';
			iEmails++;
		}
    }

	//verifica se o ltimo grupo possui pelo menos um email
	if((strlen(stconf[iEmpresa].emails[0])<4) && (iEmpresa>=0)){
		printf("Erro:O grupo %s no possui e-mail.\n",stconf[iEmpresa].empresa);
		return (-1);
	}

	//fecha o arquivo de configuracao
	fclose(arqconf);  

#ifdef DEBUG
for(iTMP=0;iTMP<=iEmpresa;iTMP++)
{
  printf("EMPRESA(%i)=%s\n",iTMP,stconf[iTMP].empresa);
	  
  for(iTMP2=0;iTMP2<iEmails;iTMP2++)
  	printf("EMAIL(%i)=%s\n",iTMP2,stconf[iTMP].emails[iTMP2]); 
}
#endif


#ifdef MYSQL_TOMEINC

	//Verifica se o arquivo de configurao MYSQL existe
	if(stat(CONF_FILE_MYSQL,&statinfo))
	{
		printf("O arquivo de configurao \"/etc/ftpmond/.mysqlconf\" no existe.\n");
		return -1;
	}

	//abre o arquivo de configurao MYSQL
	if((arqmysqlconf=fopen(CONF_FILE_MYSQL,"r"))==NULL)
	{
		printf("O arquivo de configurao \"/etc/ftpmond/.mysqlconf\" no pode ser aberto.\n");
		return -1;
    	}

	while(fgets(buff,MAXLINHA,arqmysqlconf))
    	{
    	if(!strlen(host))
    	{
			if((ptr=strstr(buff,"MYSQL_HOST="))!=NULL)
			{
				ptr+=11;
				strcpy(host,ptr);
				host[strlen(ptr)]='\0';
				continue;
			}
			else
			{
				printf("Preencha o arquivo \"/etc/ftpmond/.mysqlconf\" de acordo com o exemplo contido no arquivo INSTALL.");
				return -1;
			}
		}

    	if(!strlen(user))
    	{
			if((ptr=strstr(buff,"MYSQL_USER="))!=NULL)
			{
				ptr+=11;
				strcpy(user,ptr);
				user[strlen(ptr)]='\0';
				continue;
			}
			else
			{
				printf("Preencha o arquivo \"/etc/ftpmond/.mysqlconf\" de acordo com o exemplo contido no arquivo INSTALL.");
				return -1;
			}
		}

    	if(!strlen(password))
    	{
			if((ptr=strstr(buff,"MYSQL_PASS="))!=NULL)
			{
				ptr+=11;
				strcpy(password,ptr);
				password[strlen(ptr)]='\0';
				continue;
			}
			else
			{
				printf("Preencha o arquivo \"/etc/ftpmond/.mysqlconf\" de acordo com o exemplo contido no arquivo INSTALL.");
				return -1;
			}
		}
	
    }

	fclose(arqmysqlconf);	
#endif

#ifdef MYSQL_TOMEINC 
	printf("HOST=%s\n",host);
	printf("USERNAME=%s\n",user);
	printf("PASSWORD=%s\n",password);
#endif


	return 0;
}
