#include "main.h"


#ifdef MYSQL_TOMEINC
#include <mysql.h>
#endif

#ifdef MYSQL_TOMEINC
MYSQL mysql;
#endif

#ifdef MYSQL_TOMEINC
//Funcao que imprime o erro do banco
void vExiterr(int exitcode)
{
   printf("%s\n", mysql_error(&mysql));
   exit(exitcode);
}

//Conecta no banco Mysql
void vConnDB(char *filename)
{
  //Conecta como localhost com user e senha
  if (!(mysql_connect(&mysql,host,user,password)))
      vExiterr(1);
  //conecta ao banco de dados NOME=stArg.output
  if (mysql_select_db(&mysql,filename))
      vExiterr(2);
}

//Desconecta do banco Mysql
void vDesconDB()
{
    mysql_close(&mysql);
}
#endif




//Funo que separa os dados da linha de log
void vTokenLog(char buff[], int idx)
{
char *ptr;

	strcpy(stxferlog[idx].dsem,(ptr=strtok(buff," ")) == NULL ? "" : ptr);
	ptr++;					

	strcpy(stxferlog[idx].mes,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].diames,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].hhmmss,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].ano,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].transfer_time,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].remote_host,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].file_size,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].filename,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].transfer_type,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].special_action_flag,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].direction,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].access_mode,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].username,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].service_name,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].authentication_method,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].authenticated_user_id,(ptr=strtok(NULL," ")) == NULL ? "" : ptr);
	ptr++;

	strcpy(stxferlog[idx].completion_status,(ptr=strtok(NULL,"\n")) == NULL ? "" : ptr);

}

//Grava os logs no banco de dados Mysql
void vGrava_logBD(int idx, char *filename)
{
int cont;
char date[64],
     query[MAXLINHA];



#ifdef DEBUG
printf("Vou abrir uma conexao com o banco\n");
#endif

#ifdef MYSQL_TOMEINC
//Conecta no banco de dados
vConnDB(filename);
#endif

usleep(100000);

#ifdef DEBUG
printf("Abri uma conexao com o banco\n");
#endif

	for(cont=0;cont<idx;cont++)
	{

		//S  vlido se a direo for incomming(PUT/MPUT)
		if(strcmp(stxferlog[cont].direction,"i"))
			continue;

#ifdef DEBUG
printf("Vou preparar a String date\n");
#endif

		sprintf(date,
				"%s %s %*s %s %s",
				stxferlog[cont].dsem,
				stxferlog[cont].mes,
				2,
				stxferlog[cont].diames,
				stxferlog[cont].hhmmss,
				stxferlog[cont].ano);

#ifdef DEBUG
printf("Date OK!=\"%s\".\n",date);
#endif

#ifdef DEBUG
printf("Vou preparar a String query\n");
#endif
				
		sprintf(query,
		        "INSERT INTO tbLogFtpmond VALUES(NULL,\'%s\',\'%s\',\'%s\',\'%s\',\'%s\');",
		        date,
		        stxferlog[cont].username,
		        stxferlog[cont].filename,
		        stxferlog[cont].transfer_time,
		        stxferlog[cont].completion_status);
		        
#ifdef DEBUG
printf("Query OK, vou gravar no banco=\"%s\".\n",query);
#endif

#ifdef MYSQL_TOMEINC		        
		//Insere os dados no banco
		if (mysql_query(&mysql,query))
		    vExiterr(3);
usleep(50000);
#endif

#ifdef DEBUG
printf("Gravei no banco todos registros vlidos de ftp.\n");
#endif

	} //fim do for

#ifdef MYSQL_TOMEINC
    sprintf(query,"commit;");
    if (mysql_query(&mysql,query))
       vExiterr(3);
    usleep(50000); 
#endif


#ifdef MYSQL_TOMEINC
//Desconecta do banco
vDesconDB();
usleep(100000); 
#endif
}

//Envia e-mail para o grupo responsvel
//E-mails avisando que o arquivo X chegou ou
//e-mails avisando que o arquivo deve ser retransmitido
void vEnviar_email(int idx)
{

char buf[2048];
int i,j,cont;
char status[30];

#ifdef DEBUG
printf("\n>>>>>>>>>>>>>>>>>>>>>>>>>>> IDX: %d <<<<<<<<<<<<<<<<<<<<<<<<<<<<\n",idx);
printf("iEmpresa:%d - iEmails:%d\n",iEmpresa,iEmails);
#endif

	for(cont=0;cont<idx;cont++)
	{

		//S  vlido se a direo for incomming(PUT/MPUT)
		if(strcmp(stxferlog[cont].direction,"i"))
			continue;
			
		if(!strcmp(stxferlog[cont].completion_status,"c"))
		{
			//arquivo transferido com sucesso
			sprintf(status,"OK.\n");
		}
		else
		{
			if(!strcmp(stxferlog[cont].completion_status,"i"))
			{
				//transferncia incompleta
				sprintf(status,"INCOMPLETO.\n");
			}
			else
			{
				//status desconhecido
				sprintf(status,"desconhecido. Verifique.\n");
			}
		}

	
		for(i=0;i<=iEmpresa;i++)
		{
			if(!strcmp(stconf[i].empresa,stxferlog[cont].username))
			{
#ifdef DEBUG
printf("\nusername: {%s} - empresa: {%s}\n",stxferlog[cont].username,stconf[i].empresa);
#endif
				break;
			}
		}

		if(i<=iEmpresa)
		{
			//DOC: achou usurio no conf

			for(j=0;j<iEmails;j++)
			{
	
				//DOC: S envia emails com endereos vlidos
				if(!strlen(stconf[i].emails[j])) continue;
				sprintf(buf,"echo \""
	            "To: %s\n"
	            "Reply-to: ftpmond@uol.com.br\n"
	            "From: ftpmond@uol.com.br\n"
	            "Subject: ftpmond - %s\n"
	            "\n\n"
	            "Usurio: %s\n"
	            "Arquivo: %s\n"
	            "Status final da tranferncia: %s\n"
	            "\n\n\" | /usr/lib/sendmail -f ftpmond@uol.com.br -t %s",
				stconf[i].emails[j],
				stxferlog[cont].username,
				stxferlog[cont].username,
				stxferlog[cont].filename,
				status,
				stconf[i].emails[j]);
#ifdef DEBUG
printf("echo \""
       "To: %s\n"
       "Reply-to: ftpmond@uol.com.br\n"
       "From: ftpmond@uol.com.br\n"      
       "Subject: ftpmond - %s\n"
       "\n\n"
       "Usurio: %s\n"
       "Arquivo: %s\n"
       "Status final da tranferncia: %s\n"
       "\n\n\" | /usr/lib/sendmail -f ftpmond@uol.com.br -t %s",
	stconf[i].emails[j],
	stxferlog[cont].username,
	stxferlog[cont].username,
	stxferlog[cont].filename,
	status,
	stconf[i].emails[j]);
#endif
				system(buf);
		
			}
		}
	}

	return;

}


void vGrava_logTXT(int idx, char *filename)
{

FILE *fp;
int cont;


	if((fp=fopen(filename,"a")) == NULL)
	{
		printf("No pode abrir arquivo txt de sada: %s\n",filename);
		exit(-1);
	}

	for(cont=0;cont<idx;cont++)
	{

		//S  vlido se a direo for incomming(PUT/MPUT)
		if(strcmp(stxferlog[cont].direction,"i"))
			continue;

		fprintf(fp,
				"%s|%s|%*s|%s|%s|%s|%s|%s|%s\n",
				stxferlog[cont].dsem,
				stxferlog[cont].mes,
				2,
				stxferlog[cont].diames,
				stxferlog[cont].hhmmss,
				stxferlog[cont].ano,
		        stxferlog[cont].username,
		        stxferlog[cont].filename,
		        stxferlog[cont].transfer_time,
		        stxferlog[cont].completion_status);
	}


	fclose(fp);

	return;

}





void *ftpmond(void *arg)
{
char *ptr;
//	 *endptr,
char buff[MAXLINHA];
char tmp_pathlog[MAXLINHA];
char ultima_linha[MAXLINHA];
char tmp_linha[MAXLINHA];
struct stat statinfo;     
time_t time_new,time_old;
FILE *logfile, *lastlog;
int iFirst=0, i=0, iAchoulog=0;
char filename[255];


	// DOC: Inicializa este thread
	if(!pthread_mutex_lock(&lockx))
	{
		iniciaSignal();

		pthread_mutex_unlock(&lockx);

	}

	// DOC: loop (sem fim) principal de cada thread
	// DOC: uma vez iniciado, este loop roda at o programa principal terminar	
	for(;;)
	{

		time_new = time(NULL);

		
		if((time_new - time_old) > stArg.delay)
		{

   		//Verifica se o arquivo de log(xferlog) existe
			sprintf(tmp_pathlog,"%s/xferlog",stArg.pathlog);


			if(stat(tmp_pathlog,&statinfo))
			{
				printf("O arquivo de log \"xferlog\" que se encontra em \"%s\" no existe.\n",stArg.pathlog);
				exit(-1);
			}


			
			//Abre o arquivo de log
			if((logfile=fopen(tmp_pathlog,"r"))==NULL)
			{
				printf("O arquivo de configurao \"xferlog\" no pode ser aberto.\n");
				exit(-1);
    			}

#ifdef DEBUG
printf("POS0 - fopen logfile OK\n");
#endif

			//Abre o arquivo /etc/ftpmond/.last_log para leitura
			if((lastlog=fopen("/etc/ftpmond/.last_log","r"))==NULL)
			{
				//inicializa com vazio a varivel
				//usada para armazenar a ltima linha
				//do arquivo de log
				ultima_linha[0]='\0';
#ifdef DEBUG
printf("POS1 - last_log no existe\n");
#endif
    		}
    		else
    		{
#ifdef DEBUG
printf("POS2 - last_log existe\n");
#endif
    			//Fao a leitura da nica linha 
    			//que contem o ltimo log analizado e se o conteudo do
    			//arquivo nao for vazio usaremos a varivel ultima_linha
    			//para posicionarmos onde o programa parou.
				fgets(buff,MAXLINHA,lastlog);
				fclose(lastlog);

#ifdef DEBUG
printf("POS3 - buf: {%s}\n", buff);
#endif

				if((strlen(buff)))
				{
					ptr=buff;
					strcpy(ultima_linha,ptr);
					ultima_linha[strlen(ptr)]='\0';
				}
				else
					ultima_linha[0]='\0';
					
				ptr=ultima_linha;
				strcpy(tmp_linha,ptr);
				tmp_linha[strlen(ptr)]='\0';
#ifdef DEBUG
printf("POS4 - tmp_linha: {%s}\n",tmp_linha);				
#endif
    		}


			//Posiciona o ponteiro de arquivo no (final do arquivo - 22Kbytes), reduzindo
			//assim o tempo para encontrar a ltima linha.
			fseek(logfile, -22528, SEEK_END);
#ifdef DEBUG
printf("POS5 - fseek\n");
#endif
			//Verifica cada linha do arquivo de logs procurando pela string que representa
			//a ultima linha analisada.
			//Thu Oct 25 18:52:55 2001 0 192.168.192.44 300 /root/ftpmond.txt b _ i r lmtome ftp 0 * c
			i=iAchoulog=iFirst=0;

			while(fgets(buff,MAXLINHA,logfile))
			{

				//Rejeita a primeira linha de logs
				if(!iFirst)
				{
					iFirst++;
					continue;
				}
				
				//Se ultima_linha for vazio o que me interessa eh exatamente 
				//ltima linha do log.
				//Se a ultima_linha nao for vazia terei que guardar
				//todas as linhas apartir da ultima linha analizada e 
				//mandar e-mail para todas.

#ifdef DEBUG
printf("POS6 - buff: {%s}\n",buff);
#endif

				if(strlen(ultima_linha))
				{
					ptr=buff;
					//Se achou o ultimo log, pula esse log para guardar o(s) proximo(s)

#ifdef DEBUG
printf("ptr: {%s}\nultima_linha: {%s}\n", ptr, ultima_linha);
#endif

					//if((strstr(ptr,ultima_linha))!=NULL)
					if(!(strncmp(ptr,ultima_linha,25)))
					{
#ifdef DEBUG
printf("POS7 - LINHA IGUAL ----ACHOU!!!\n");
#endif
						iAchoulog++;
						continue;
					}
					else
					{
#ifdef DEBUG
printf("POS8 - LINHA DIFERENTE\n");
#endif
						//verifica se esse log esta antes ou depois do 
						//ltimo log analisado
						//Se iAchoulog=0 eh porque esse log est antes
						//ou todos os 22K de logs que temos so logs
						//nao analisados(INICIALMENTE ESTAMOS GARANTINDO AT
						//2 DIAS DE FTPMOND PARADO, MAIS QUE ISSO NO)
						if(iAchoulog)
						{
							//caso esse log esteja depois do ultimo analisado
							//guardaremos num array de struct para armazenar no banco
							// e mandar e-mail avisando
							vTokenLog(buff,i);
							i++;
						}
					}						
				}
				else
				{
					vTokenLog(buff,0);//separa os campos da linha de log e guarda na struct
#ifdef DEBUG
printf("POS9 - Tokenlog\n");
#endif
				}
			}
#ifdef DEBUG
printf("POS10 - Fim while fgets\n");
#endif
			if(!(strlen(tmp_linha)))
				i=1;
#ifdef DEBUG
printf("\n>>>>>>>>>>>>>>>>>>>**********>>>>>>>>>>>>>>>>>>>>>>. i: %d\n",i);
#endif


				iFirst=i-1;
				
				sprintf(ultima_linha,
						"%s %s %*s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
						stxferlog[iFirst].dsem,
						stxferlog[iFirst].mes,
						2,
						stxferlog[iFirst].diames,
						stxferlog[iFirst].hhmmss,
						stxferlog[iFirst].ano,
						stxferlog[iFirst].transfer_time,
						stxferlog[iFirst].remote_host,
						stxferlog[iFirst].file_size,
						stxferlog[iFirst].filename,
						stxferlog[iFirst].transfer_type,
						stxferlog[iFirst].special_action_flag,
						stxferlog[iFirst].direction,
						stxferlog[iFirst].access_mode,
						stxferlog[iFirst].username,
						stxferlog[iFirst].service_name,
						stxferlog[iFirst].authentication_method,
						stxferlog[iFirst].authenticated_user_id,
						stxferlog[iFirst].completion_status);


				//S ser gravado no banco registros novos de log
				//seguido com aviso por e-mail para o responsvel
				if(strlen(stxferlog[0].dsem))
				{

					//Abre o arquivo /etc/ftpmond/.last_log
					if((lastlog=fopen("/etc/ftpmond/.last_log","w+"))==NULL)
					{
						printf("No foi possvel abrir o arquivo \"/etc/ftpmond/.last_log\" para gravao.\n");
						exit(-1);
	    			}
				
					//grava a ltima linha.
#ifdef DEBUG
printf("POS11 - gravando ultima_linha last_log: {%s}\n",ultima_linha);
#endif

					fprintf(lastlog,"%s",ultima_linha);
					usleep(50000);				
					fclose(lastlog);
						

					if(strlen(tmp_linha))
					{
						ptr=stArg.output;
						if(!(strncmp(ptr,"mysql=",6)))
						{
							ptr+=6;
							strcpy(filename,ptr);
							filename[strlen(ptr)]='\0';
							vGrava_logBD(i, filename);
							sleep(2);
						}
						else if(!(strncmp(ptr,"txt=",4)))
						{
							ptr+=4;
							strcpy(filename,ptr);
							filename[strlen(ptr)]='\0';
							vGrava_logTXT(i,filename);								
						}

						vEnviar_email(i);

					}
				}
 		   
 		   //Iniciliza variavel que ser verificada 
 		   //para saber se tem algum registro de log
 		   //novo
 		   stxferlog[0].dsem[0]='\0';
#ifdef DEBUG
printf("====================================================================\n"); 		   
#endif

    		//Inicializa delay
			time_old=time_new;

		}
		
		// DOC: Dorme 100mseg
		// DOC: o suficiente para evitar que o loop principal de cada thread consuma toda a cpu da mquina
		usleep(100000);

	}

   return arg;

}
