#define MAIN_CALLING
#include "main.h"
#undef MAIN_CALLING

int main(int argc, char* argv[])
{

#ifdef GERAR_PID_FILE
	FILE *fp;
#endif

	//captura os parametros da linha de comando
	IniciaVars(argv[0]);

	// DOC: ler commnand line
	if(!lerCommandLine(argc,argv)) return 1;

	// DOC: inicia sinais e rotinas de tratamento dos mesmos
	iniciaSignal();

	// DOC: carrega valores de dentro do arquivo de configurao
	if(ichkConfigFile())
	{
		printf("Erro no arquivo de configurao ftpmond.conf, favor verificar.\n");
		exit(-1);
	}

	// DOC: gera arquivo com PID deste processo
#ifdef GERAR_PID_FILE
	if((fp = fopen(PIDFile,"w")) != NULL)
	{
		fprintf(fp,"%d",(pid_t)getpid());
#ifdef DEBUG
printf("PID: %d\n",(pid_t)getpid());
#endif
		fclose(fp);
	}
	else
	{
		printf("No posso criar arquivo com PID do processo\n");
		exit(-1);
	}
#endif


	// DOC: cria threads
	criaThreads();

	// Mutex de sincronizao inicial
	if(pthread_mutex_lock(&lockx) != 0)
		printf("ERRO! mutex_lock inicial falhou.\n\n");
	pthread_mutex_unlock(&lockx);

	// Loop principal
	for(;;)
	{
		pause();
		usleep(MANAGER_SLEEP_TIME_SEC*1000000);
#ifdef DEBUG
printf("saiu usleep principal\n");
#endif
	}


	return 0;

}



bool lerCommandLine(int argc, char* argv[])
{
	int i;
				
	while((i = getopt(argc,argv,"l:d:o:v")) != EOF)
	{
		switch(i)
		{

			case 'l': //path do arquivo de log a ser examinado. 
					strncpy(stArg.pathlog,optarg,255);
					stArg.pathlog[255] = '\0';
					break;

			case 'd': //delay
					stArg.delay = (int)atoi(optarg);
					break;
			case 'o': //output file
					strncpy(stArg.output,optarg,255);
					stArg.output[255] = '\0';
#ifdef DEBUG
printf("ARQUIVO OUTPUT: {%s}\n",stArg.output);				
#endif
					break;
			case 'v': // verso
					printf("ftpmond verso 1.11 1310(release)\n");			
					exit(0);
					break;
			default: //help
					printf("Usage:ftpmond [-l <path log> -o <[mysql,txt]> -d<segundos> -v{exibe a verso}]\n");
					exit(0);
					break;
		}

	}

	return true;
}


void IniciaVars(char *binName)
{

#ifdef GERAR_PID_FILE
		sprintf(PIDFile,"%s/%s.pid",PIDFILEPATHDIR, binName);
#endif

	stArg.delay=INIT_DELAY;
	strcpy(stArg.pathlog,INIT_PATHLOG);
	strcpy(stArg.output,INIT_OUTPUT);
}


void criaThreads(void)
{

	void *arg = NULL;

	// DOC: cria mutex para sincronizaao dos threads
	if(pthread_mutex_init(&lockx,NULL))
	{
		perror("\erro em criaManager - mutex\n");
		exit(1);
	}

#ifdef DEBUG
printf("mutex init OK\n");	
#endif


	// DOC: thread principal
	if(pthread_create(&tmain.main,NULL,ftpmond,arg))
	{
		printf("ERRO - thread main: %s\n",strerror(errno));
		exit(1);
	}


}



