#ifndef MAIN_H
#define MAIN_H


const int MAX_AUX_THREADS          = 3;
const int MANAGER_SLEEP_TIME_SEC   = 300;


// INCLUDES
#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <memory.h>
#include <pthread.h>
#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>
#include <utime.h>

//DEFINES


#ifdef MAIN_CALLING
#define GLOBAL
#else
#define GLOBAL extern
#endif

#ifdef GERAR_PID_FILE
#define PIDFILEPATHDIR "./"
#endif

//delay inicial caso nao seja usado o parametro -d
#define INIT_DELAY 10 
//path log inicial caso nao seja usado o parametro -l
#define INIT_PATHLOG "/var/log"
//output padro caso no seja usado o parmetro -o para especificar
#define INIT_OUTPUT "txt=/var/log/ftpmond.log"
//Arquivo de configurao para criao de grupos de e-mails
#define CONF_FILE "/etc/ftpmond/ftpmond.conf"
//Arquivo de configurao para criao de grupos de e-mails
#define CONF_FILE_MYSQL "/etc/ftpmond/.mysqlconf"
//Tamanho mximo de uma linha de para o buffer de arquivo
#define MAXLINHA 1024


//VARIVEIS GLOBAIS

// Semforo de threads
GLOBAL pthread_mutex_t lockx;

// Struct thread principal
GLOBAL struct tmainStruct
{
	pthread_t main;
}tmain;

// Struct thread hupthread
GLOBAL struct thupStruct
{
	pthread_t hup;
}thup;

// Struct threads de processamento
GLOBAL struct tidStruct
{
  pthread_t req[MAX_AUX_THREADS];
  bool used[MAX_AUX_THREADS];
}tid;


//Estrutura usada para guardar os novos paramentros passados por linha de comando
GLOBAL struct STArg
{
  int delay;
  char pathlog[255];
  char output[255];
}stArg;

//estrutura usada para guardar os novos grupos de e-mails
GLOBAL struct STConf_file
{
  char empresa[255];
  char emails[64][128];
}stconf[512];

//Struct para guardar os valores de cada campo da linha no arquivo xferlog
GLOBAL struct STXferlog
{
char dsem[5], //usado
	 mes[5], //usado
 	diames[4], //usado
 	hhmmss[11], //usado
 	ano[6], //usado
 	transfer_time[3],//usado
	 remote_host[17],
	 file_size[64],
	 filename[256],//usado
	 transfer_type[3],
 	special_action_flag[3],
 	direction[3],//usado
 	access_mode[3],
 	username[128],//usado
     service_name[64],
 	authentication_method[3],
 	authenticated_user_id[128],
 	completion_status[3]; //usado
}stxferlog[256];

#ifdef GERAR_PID_FILE
  GLOBAL char PIDFile[80];
#endif

GLOBAL int iEmpresa;
GLOBAL int iEmails;
#ifdef MYSQL_TOMEINC
GLOBAL char host[128],
            user[128],
            password[128];
#endif

// DOC: prottipos
void* hupThread(void *ptr);
void* ftpmond(void *arg);
void  iniciaSignal(void);
void IniciaVars(char *binName);
bool  lerCommandLine(int argc, char* argv[]);
void  criaThreads(void);

int ichkConfigFile();
void vParam(int argc, char **argv);
void vTokenLog(char buff[], int idx);
void vEnviar_email(int idx);
void vGrava_logBD(int idx);
#ifdef MYSQL_TOMEINC
void vExiterr(int exitcode);
void vConnDB(char *filename);
void vDesconDB();
#endif
void vGrava_logTXT(int idx);



#undef GLOBAL

#endif
