#include "main.h"

void catch_sig(int sig_num);

void iniciaSignal(void)
{

	signal(SIGPIPE,catch_sig);  // erro na tentativa de ler socket
	signal(SIGHUP,catch_sig);   // kill -HUP <pid>
	signal(SIGTERM,catch_sig);  // kill <pid>
	signal(SIGINT,catch_sig);   // <ctrl> <C>  (usando pelo debug)
	signal(SIGSEGV,catch_sig);  // segment fault (pode ser gerador por referncia a NULL pointer)
	signal(SIGALRM,catch_sig);  // alarm, usado para time-out de funoes BLOCKING
	signal(SIGUSR1,catch_sig);  // usado pelos threads
	signal(SIGUSR2,catch_sig);  // usado pelo thread processador de "kill -HUP"

}

void catch_sig(int sig_num)
{

	switch(sig_num)
	{
		case SIGPIPE:
					break;
		case SIGTERM:// kill
		case SIGINT: // <ctrl><C>
					// encerra programa
					pthread_kill(tmain.main,SIGTERM);
//					signal(sig_num,SIG_DFL);// normaliza
					exit(0);
					break;
		case SIGHUP:
					if(!pthread_mutex_lock(&lockx))
					{
#ifdef DEBUG
printf("Capturado um HUP....\n");
#endif
						if(ichkConfigFile())
						{
						printf("Erro no arquivo de configurao ftpmond.conf, favor verificar.\n");
							pthread_kill(tmain.main,SIGTERM);
//							signal(sig_num,SIG_DFL);// normaliza
							exit(-1);
						}
						pthread_mutex_unlock(&lockx);
					}
					break;
		    case SIGSEGV:
					signal(sig_num,SIG_DFL);// normaliza SIGSEGV
					break;
		    case SIGALRM:
					signal(sig_num,SIG_DFL);// normaliza SIGSEGV
					break;
		    default:
					break;

		}

}

